﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;

namespace WizardProgressBarLibrary.Converters
{
    public class IsProgressedConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
           ContentPresenter contentPresenter = values[0] as ContentPresenter;
           if (contentPresenter == null)
           {
              return Visibility.Collapsed;
           }
           if (!(values[1] is int))
              return Visibility.Collapsed;
           int progress = (int)values[1];
           ItemsControl itemsControl = ItemsControl.ItemsControlFromItemContainer(contentPresenter);
           if (itemsControl == null)
           {
              return Visibility.Collapsed;
           }
           WizardProgressBar wizardProgressBar = itemsControl.TemplatedParent as WizardProgressBar;
           if (wizardProgressBar == null)
              return Visibility.Collapsed;
           int index = itemsControl.ItemContainerGenerator.IndexFromContainer(contentPresenter);
           bool checkNextItem = System.Convert.ToBoolean(parameter.ToString());
           if (checkNextItem)
           {
              index++;
           }
           int percent = (int) (((double) index/wizardProgressBar.Items.Count)*100);
           return (percent < progress) ? Visibility.Visible : Visibility.Collapsed;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
