﻿using System.Windows;
using System.Windows.Controls;

namespace WizardProgressBarLibrary
{
    public class WizardProgressBar : ItemsControl
    {
        #region Dependency Properties

        public static DependencyProperty ProgressProperty =
            DependencyProperty.Register("Progress",
                                        typeof(int),
                                        typeof(WizardProgressBar),
                                        new FrameworkPropertyMetadata(0, null, CoerceProgress));

       internal static object CoerceProgress(DependencyObject target, object value)
        {
            int progress = (int)value;
            if (progress < 0)
            {
                progress = 0;
            }
            else if (progress > 100)
            {
                progress = 100;
            }
            return progress;
        }

        #endregion // Dependency Properties

        static WizardProgressBar()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(WizardProgressBar), new FrameworkPropertyMetadata(typeof(WizardProgressBar)));
        }


        #region Properties

        public int Progress
        {
            get { return (int)GetValue(ProgressProperty); }
            set { SetValue(ProgressProperty, value); }
        }

        #endregion // Properties
    }
}
