﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WizardProgressBarLibrary
{
   /// <summary>
   /// Interaction logic for WizardProgressBarCtl.xaml
   /// </summary>
   public partial class WizardProgressBarCtl : UserControl
   {
      public WizardProgressBarCtl()
      {
         DefaultStyleKeyProperty.OverrideMetadata(typeof(WizardProgressBarCtl), new FrameworkPropertyMetadata(typeof(WizardProgressBarCtl)));
         InitializeComponent();
      }

      #region Dependency Properties

      public static DependencyProperty ProgressProperty =
          DependencyProperty.Register("Progress",
                                      typeof(int),
                                      typeof(WizardProgressBarCtl),
                                      new FrameworkPropertyMetadata(0, null, CoerceProgress));

      private static object CoerceProgress(DependencyObject target, object value)
      {
         return WizardProgressBar.CoerceProgress(target, value);
      }


      public static DependencyProperty BarItemsProperty = 
         DependencyProperty.Register("BarItems",
                           typeof(IEnumerable),
                           typeof(WizardProgressBarCtl)
                           );

      public IEnumerable BarItems
      {
         get { return internalBar.ItemsSource; }
         set { internalBar.ItemsSource = value; }
      }

      #endregion // Dependency Properties
   }
}
